using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using PCIELM4_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace DIO
{
    public partial class frm_Diag : Form
    {
        public frm_Diag()
        {
            InitializeComponent();
        }



        UInt16 wTotalBoards, wRtn, wBoardNo;
        UInt32 dwDataNum;
        UInt16 wChannel;
        UInt16 wConfig;
        UInt32 lAIRate;
        UInt16 iGain;
        PCIELM4_DLL.PCIELM4_CARD_INFO[] sCardInfo = new PCIELM4_DLL.PCIELM4_CARD_INFO[PCIELM4_DLL.MAX_BOARD_NUMBER];
        PCIELM4_DLL.PCIELM4_DEVICE_INFO[] sDevInfo = new PCIELM4_DLL.PCIELM4_DEVICE_INFO[PCIELM4_DLL.MAX_BOARD_NUMBER];

        Single fRangeMax;
        Single fRangeMin;

    
       
        ArrayList mpbo = new ArrayList();
        ArrayList mpbi = new ArrayList();
        ArrayList YScale = new ArrayList();
        Single[] YS = new Single[2];
        UInt32[] lBuf = new UInt32[1000];
        double[] fBuf = new double[1000];

       
        private void Form1_Load(object sender, EventArgs e)
        {
            
            byte[] szModelName = new byte[20];
            UInt16 wBoardIndex;

            dwDataNum = Convert.ToUInt16(this.tbxDataNum.Text);
           
            //Driver Initial
            wRtn = PCIELM4_DLL.PCIELM4_DriverInit(ref wTotalBoards);
            if (wRtn != PCIELM4_DLL.PCIELM4_NoErr){
                MessageBox.Show("Driver Initial Error!!Error Code:" + Convert.ToString(wRtn));
                Close();
                return;
            }
            
            
            //Get Card Information
            for (wBoardIndex = 0 ; wBoardIndex <= wTotalBoards - 1 ; wBoardIndex++){

                wRtn = PCIELM4_DLL.PCIELM4_GetCardInfo(wBoardIndex, ref sDevInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModelName);

                if (wRtn != PCIELM4_DLL.PCIELM4_NoErr){
                    MessageBox.Show("Get Card Information Err");
                }
                this.cbxBoardNo.Items.Add(Convert.ToSingle(wBoardIndex) + " " + Encoding.ASCII.GetString(szModelName));
            }
            
          mpbo = ControlArrayUtils.getControlArray(this.gbxIO, "cbout",""); //CreatControlArray
        mpbi = ControlArrayUtils.getControlArray(this.gbxIO, "pbin","");  //CreatControlArray     
        YScale = ControlArrayUtils.getControlArray(this.frmAI, "yscale","");  //CreatControlArray
    
        for (int i = 1  ; i <= 16 ; i++){
            
           ((PictureBox)mpbi[i]).BackColor = Color.Gray;
            
            ((PictureBox)mpbi[i]).Enabled = false;

            ((CheckBox)mpbo[i]).Enabled = false;
            
            ((CheckBox)mpbo[i]).Click += new EventHandler(mpbo_Click); //mpbo Click event

        }

     
        this.cbxBoardNo.SelectedIndex = 0;
  
        }

        private void mpbo_Click(object sender, EventArgs e) //mpbOutputs Click event
        {

            wBoardNo = (UInt16)cbxBoardNo.SelectedIndex;
            uint DoVal;
            int index;
  
            DoVal = 0;
            for (index = 1; index <= 16; index++)
            {
                if (((CheckBox)mpbo[index]).Checked == true)
                {
                    uint shiftDO = 1;
                    DoVal = (DoVal | (shiftDO << (index-1)));
                }
            }
            //Write DO port
            wRtn = PCIELM4_DLL.PCIELM4_WriteDO(wBoardNo, DoVal);
        }

        private void cbxBoardNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            UInt16 AIChIndex;
            wBoardNo = (UInt16)cbxBoardNo.SelectedIndex;

            this.Text = this.cbxBoardNo.Text + " Motor Card Diag[ID:" + Convert.ToString(sCardInfo[wBoardNo].CardID) + "]";


        if (sCardInfo[wBoardNo].wAIChannels > 0) {

            for (AIChIndex = 0 ;AIChIndex <= sCardInfo[wBoardNo].wAIChannels - 1 ; AIChIndex++){

                if (AIChIndex < 4) {
                    cbxAICh.Items.Add("CH" + Convert.ToString(AIChIndex) + "[Load Cell]");
                }else{
                    cbxAICh.Items.Add("CH" + Convert.ToString(AIChIndex) + "[General]");
                }
            }
            cbxAICh.SelectedIndex = 4;
            cbxAIRate.SelectedIndex = 6;
            this.cbxAICfgCode.SelectedIndex = 1;
        }

        wRtn = PCIELM4_DLL.PCIELM4_ConfigAO(0, 0, 0, PCIELM4_DLL.PCIELM4_AO_BI_10V);

        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Config AO0 Error Error Code:" + Convert.ToString(wRtn));
        }

        wRtn = PCIELM4_DLL.PCIELM4_ConfigAO(0, 1, 0, PCIELM4_DLL.PCIELM4_AO_BI_10V);

        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Config AO1 Error Error Code:" + Convert.ToString(wRtn));
        }

        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            wRtn = PCIELM4_DLL.PCIELM4_DriverClose();
        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr){
            MessageBox.Show("Driver Close Error Code : " + Convert.ToString(wRtn));
        }
            Close();
            return;
        }

        private void cmdActive_Click(object sender, EventArgs e)
        {
        UInt16 index;

        wBoardNo = (UInt16)this.cbxBoardNo.SelectedIndex;
        wChannel = (UInt16)this.cbxAICh.SelectedIndex;
        wConfig = (UInt16)this.cbxAICfgCode.SelectedIndex;


        if (cmdActive.Text == "&ACTIVE"){
            cmdActive.Text = "&STOP";
            cmdExit.Enabled = false;

            this.tmrDI.Enabled = true;

            for (index = 1 ; index <= 16 ; index++){
                ((CheckBox)mpbo[index]).Enabled = true;

            }

        }else{
            cmdActive.Text = "&ACTIVE";

            cmdExit.Enabled = true;
            this.tmrDI.Enabled = false;

            for (index = 1 ; index <= 16 ; index++){
                ((CheckBox)mpbo[index]).Enabled = false;

            }
        }
        }

        private void tmrDI_Tick(object sender, EventArgs e)
        {
            
        UInt32 wInputVal = 0x0; 
        UInt16 index ;


      

        //Read Digital Input port Val
        wRtn = PCIELM4_DLL.PCIELM4_ReadDI(wBoardNo, ref wInputVal);
          if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Read DI port Error!!!");
        }


        for (index = 1; index <=16 ; index++){

            if ((wInputVal & (UInt32)(Math.Pow(2, (index - 1)))) == 0){
                ((PictureBox)mpbi[index]).BackColor = Color.Gray;
            }else{
                ((PictureBox)mpbi[index]).BackColor = Color.Red;
            }
        }
        }

        private void optDAhex_CheckedChanged(object sender, EventArgs e)
        {
            this.lblDACH0Type.Text = "HEX";

        }

        private void optDAVol_CheckedChanged(object sender, EventArgs e)
        {
            this.lblDACH0Type.Text = "V";
            this.optSin.Enabled = true;
        }

        private void optDC_CheckedChanged(object sender, EventArgs e)
        {
            this.cmdAOCH0.Text = "Output DC";
            this.cmdAOStop.Enabled = false;
        }

        private void optSin_CheckedChanged(object sender, EventArgs e)
        {
            this.cmdAOCH0.Text = "Active";
            this.cmdAOStop.Enabled = false;
        }

        private void cmdAOCH0_Click(object sender, EventArgs e)
        {
        UInt32 wDaOutputNum;
        UInt32 wIndex ;
        float[] fDAVal = new float[512];
        UInt32[] dwDAVal = new UInt32[512] ;
        Int32 HEXtoInt;

        if (this.cmdAOCH0.Text == "Active") {
            this.optDC.Enabled = false;
            this.optDAVol.Enabled = false;
            this.optSin.Enabled = false;
            this.optDAhex.Enabled = false;
        }

        wRtn = PCIELM4_DLL.PCIELM4_ConfigAO(wBoardNo, 0, 0, PCIELM4_DLL.PCIELM4_AO_BI_10V);

        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Config AO0 Error Error Code:"  + Convert.ToString(wRtn));
        }

        this.List1.Items.Clear();
        
        ////Static
        if (this.optDC.Checked ==true){

            if (this.optDAhex.Checked == true){
                wRtn = PCIELM4_DLL.PCIELM4_WriteAOVoltageH(wBoardNo, 0, Convert.ToUInt32(this.tbxAOCH0Val.Text,16));
            }else{
                wRtn = PCIELM4_DLL.PCIELM4_WriteAOVoltage(wBoardNo, 0, Convert.ToSingle(this.tbxAOCH0Val.Text));
            }
            if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
                MessageBox.Show("Write AO Error Error Code:" + Convert.ToString(wRtn));
            }
            
        }else{ ////Wave generator

            this.cmdAOStop.Enabled = true;
            this.cmdAOCH0.Enabled = false;
            wDaOutputNum = 500;

            if (this.optDAhex.Checked == true) {


                HEXtoInt = Convert.ToInt32(this.tbxAOCH0Val.Text,16);
                if (HEXtoInt < 0){
                   HEXtoInt = HEXtoInt + 65535;
                }
                for (wIndex = 0; wIndex <=  wDaOutputNum - 1 ; wIndex++){
                    fDAVal[wIndex] = (float)(((HEXtoInt / 65535.0) * (fRangeMax - fRangeMin) + fRangeMin) * Math.Sin((2 * 3.14159 / wDaOutputNum) * wIndex));
                    dwDAVal[wIndex] = Convert.ToUInt32(((fDAVal[wIndex] - fRangeMin) / (fRangeMax - fRangeMin)) * 65535);
               
                    this.List1.Items.Add(Convert.ToString(wIndex) + " " + Convert.ToString(dwDAVal[wIndex],16));
                }
         

                ////Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_DLL.PCIELM4_StartAOVoltageALLH(wBoardNo, Convert.ToSingle(this.tbxAOfreq.Text) * Convert.ToSingle(wDaOutputNum), wDaOutputNum, 0, dwDAVal, dwDAVal);
            }else{
                for (wIndex = 0 ; wIndex <= wDaOutputNum - 1 ; wIndex++){
                    fDAVal[wIndex] = (float)(Convert.ToSingle(this.tbxAOCH0Val.Text) * Math.Sin((2 * 3.14159 / wDaOutputNum) * wIndex)); //+ CSng(Me.tbxOffset.Text)
                    this.List1.Items.Add(Convert.ToString(wIndex) + " " + Convert.ToString(fDAVal[wIndex]));

                }

                ////Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_DLL.PCIELM4_StartAOVoltageALL(wBoardNo, Convert.ToSingle(this.tbxAOfreq.Text) * Convert.ToSingle(wDaOutputNum), wDaOutputNum, 0, fDAVal, fDAVal);

            }


            if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
                this.cmdAOStop.Enabled = false;
                this.cmdAOCH0.Enabled = true;
                MessageBox.Show("Write AO Error Error Code:" + Convert.ToString(wRtn));
            }
        }
        }

        private void cmdAOStop_Click(object sender, EventArgs e)
        {
            wRtn = PCIELM4_DLL.PCIELM4_StopAOALL(wBoardNo);

            this.cmdAOCH0.Enabled = true;
            if (this.cmdAOCH0.Text == "Active")
            {
                this.optDC.Enabled = true;
                this.optDAVol.Enabled = true;
                this.optSin.Enabled = true;
                this.optDAhex.Enabled = true;
            }
        }

        private void optDA1hex_CheckedChanged(object sender, EventArgs e)
        {
            this.lblDACH1Type.Text = "HEX";
        }

        private void optDA1Vol_CheckedChanged(object sender, EventArgs e)
        {
            this.lblDACH1Type.Text = "V";
        }

        private void cmdAOCH1_Click(object sender, EventArgs e)
        {
            wRtn = PCIELM4_DLL.PCIELM4_ConfigAO(0, 1, 0, PCIELM4_DLL.PCIELM4_AO_BI_10V);

        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Config AO1 Error Error Code:" + Convert.ToString(wRtn));
        }



        if (this.optDA1hex.Checked == true) {
            wRtn = PCIELM4_DLL.PCIELM4_WriteAOVoltageH(wBoardNo, 1, Convert.ToUInt32( (this.tbxAOCH1Val.Text),16));
        }else{
            wRtn = PCIELM4_DLL.PCIELM4_WriteAOVoltage(wBoardNo, 1, Convert.ToSingle(this.tbxAOCH1Val.Text));
        }
        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("Write AO Error Error Code:" + Convert.ToString(wRtn));
        }

        }

        private void optAIHex_CheckedChanged(object sender, EventArgs e)
        {
            if (optAIHex.Checked == true){
            ((TextBox)YScale[0]).Text = "0x7FFFFF";
            ((TextBox)YScale[1]).Text = "0x800000";
            }else{
          
            ((TextBox)YScale[0]).Text = String.Format("{0:0.000}", fRangeMax*1.1);
            ((TextBox)YScale[1]).Text = String.Format("{0:0.000}", fRangeMin*1.1);
            }
        }

        private void cbxAICfgCode_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch(cbxAICfgCode.SelectedIndex)
            {

                case PCIELM4_DLL.PCIELM4_AI_BI_10V:
                fRangeMax = 10.0F;
                fRangeMin = -10.0F;
                break;

                case PCIELM4_DLL.PCIELM4_AI_BI_5V:    //1  //Bipolar +/-  5V
                fRangeMax = 5.0F;
                fRangeMin = -5.0F;
                break;

                case PCIELM4_DLL.PCIELM4_AI_BI_2V5:     //2 //Bipolar +/-  2.5V
                fRangeMax = 2.5F;
                fRangeMin = -2.5F;
                break;

                case PCIELM4_DLL.PCIELM4_AI_BI_1V25:    //3 //Bipolar +/-  1.25V
                fRangeMax = 1.25F;
                fRangeMin = -1.25F;
                break;

                case 4:    //3 //Bipolar +/-  227mV
                fRangeMax = 227.3F;
                fRangeMin = -227.3F;
                break;
            }

        YS[0] = (Single)(fRangeMax * 1.1);
        
        ((TextBox)YScale[0]).Text = String.Format("{0:0.000}", fRangeMax * 1.1);
        
        YS[1] = (Single)(fRangeMin * 1.1);
        ((TextBox)YScale[1]).Text = String.Format("{0:0.000}", fRangeMin * 1.1);


        this.optAIFloat.Text = "V";
        }

        private void cbxAIRate_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cbxAIRate.SelectedIndex)
            {

                case 0:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_15000;
                    break;
                case 1:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_7500;
                    break;
                case 2:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_3750;
                    break;
                case 3:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_1000;
                    break;
                case 4:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_500;
                    break;
                case 5:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_30;
                    break;
                case 6:
                    lAIRate = PCIELM4_DLL.PCIELM4_AIRATE_15;
                    break;


            }
        }

        private void cbxAICh_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.cbxAICh.SelectedIndex < 4 ){
            this.cbxAICfgCode.Enabled = false;
            iGain = 1000;

            fRangeMax = (float)(0.2273 * iGain );
            fRangeMin = (float)(-0.2273 * iGain );

            ((TextBox)YScale[0]).Text = String.Format("{0:0.000}", fRangeMax * 1.1);
            ((TextBox)YScale[1]).Text = String.Format("{0:0.000}", fRangeMin * 1.1);
           
            YS[0] = fRangeMax;
            YS[1] = fRangeMin;

            
            this.chkAutoZeroEnable.Visible = true;
            this.tbxAutoZeroVal.Visible = true;
            this.cmdSaveAutozeroVal.Visible = true;
            cbxAICfgCode.SelectedIndex = 0;
            cbxAICfgCode.SelectedIndex = 4;
            this.optAIFloat.Text = "mV";
            }else{
            iGain = 1;
            this.chkAutoZeroEnable.Visible = false;
            this.tbxAutoZeroVal.Visible = false;
            this.cmdSaveAutozeroVal.Visible = false;
            this.cbxAICfgCode.Enabled = true;
            this.cbxAICfgCode.SelectedIndex = 1;
            this.optAIFloat.Text = "V";
            cbxAICfgCode.SelectedIndex = 0;
            cbxAICfgCode.SelectedIndex = 1;
            }

        }

        private void tbxDataNum_TextChanged(object sender, EventArgs e)
        {
            dwDataNum = Convert.ToUInt16(this.tbxDataNum.Text);
        }

        private void chkAutoZeroEnable_CheckedChanged(object sender, EventArgs e)
        {
            if (chkAutoZeroEnable.Checked == true){
                wRtn = PCIELM4_DLL.PCIELM4_ConfigAIAutoZero(wBoardNo, (UInt16)this.cbxAICh.SelectedIndex, 1);
            }else{
                wRtn = PCIELM4_DLL.PCIELM4_ConfigAIAutoZero(wBoardNo, (UInt16)this.cbxAICh.SelectedIndex, 0);
            }
        }

        private void cmdSaveAutozeroVal_Click(object sender, EventArgs e)
        {
            wRtn = PCIELM4_DLL.PCIELM4_SaveAIAutoZeroVal(wBoardNo, (UInt16)this.cbxAICh.SelectedIndex, lAIRate, Convert.ToUInt32(this.tbxAutoZeroVal.Text, 16));
            if (chkAutoZeroEnable.Checked == true)
            {
                wRtn = PCIELM4_DLL.PCIELM4_ConfigAIAutoZero(wBoardNo, (UInt16)this.cbxAICh.SelectedIndex, 1);
            }
        }

        private void cmdAITrigger_Click(object sender, EventArgs e)
        {
            
        UInt16 i;
        Graphics gr = pbxDisplay.CreateGraphics();

        wBoardNo = (UInt16)this.cbxBoardNo.SelectedIndex;
        wChannel = (UInt16)this.cbxAICh.SelectedIndex;
        wConfig = (UInt16)this.cbxAICfgCode.SelectedIndex;
        if (wConfig == 4) {
            wConfig = PCIELM4_DLL.PCIELM4_AI_BI_227MV;
        }


        this.cmdAITrigger.Enabled = false;
        this.List1.Items.Clear();
        wRtn = PCIELM4_DLL.PCIELM4_ConfigAI(wBoardNo, 0, 0, 0, 0, 0);
        if (this.optAIHex.Checked == true) {
            //Get the A/D data on Software Polling Mode
            wRtn = PCIELM4_DLL.PCIELM4_PollingAIH(wBoardNo, wChannel, wConfig, lAIRate, dwDataNum,lBuf);
            for (i = 0 ; i <=  (dwDataNum - 1) ; i++){
      
                if ((lBuf[i] >= 0) && lBuf[i] < 0x800000 ){

                    fBuf[i] = Convert.ToDouble((fRangeMax - fRangeMin) / 2) * (Convert.ToDouble(lBuf[i]) / Convert.ToDouble(0x7FFFFF));
                }else{
                    fBuf[i] = Convert.ToDouble((fRangeMax - fRangeMin) / 2) * (Convert.ToDouble(lBuf[i] - Convert.ToDouble(0xFFFFFF)) / Convert.ToDouble(0x7FFFFF));
                }
                if (this.cbxAICh.SelectedIndex < 4) {
                    fBuf[i] = fBuf[i] / 1000.0;
                }
            }
        }else{
     
            //Get the A/D data on Software Polling Mode
            wRtn = PCIELM4_DLL.PCIELM4_PollingAI(wBoardNo, wChannel, wConfig, lAIRate, dwDataNum, fBuf);
        }
        if (wRtn != PCIELM4_DLL.PCIELM4_NoErr) {
            MessageBox.Show("AD Polling Error|!Error Code:" + Convert.ToString(wRtn));
            this.cmdAITrigger.Enabled = true;
            return;
        }

        fBuf[0] = fBuf[0] * iGain;
        //Draw the Wave    

        if (this.optAIHex.Checked == true) {
            this.List1.Items.Add("000  &H" + Convert.ToString(lBuf[0]));
            this.tbxAutoZeroVal.Text = Convert.ToString(lBuf[0],16);

        }else{

            this.List1.Items.Add("000" + "  " + String.Format("{0:00.000}", fBuf[0]));
        }

        for (i = 1 ; i <= (dwDataNum - 1) ;i++){

            fBuf[i] = fBuf[i] * iGain;
            

            if (this.optAIHex.Checked == true){
                this.List1.Items.Add(String.Format("{0:000}",i)+"  &H" + Convert.ToString(lBuf[i]));

            }else{

                this.List1.Items.Add(String.Format("{0:000}",i)+"  " + String.Format("{0:00.000}",fBuf[i]));
                

            }


        }

        if (dwDataNum > 1) { PlotData(gr); }
        else {
            pbxDisplay.Refresh();
        }
            
        Application.DoEvents();

        this.cmdAITrigger.Enabled = true;
        }
        private void PlotData(Graphics g)
        {
      
            Single fScaleX, fScaleY;
            Pen RedPen = new Pen(Color.Red);
            Pen BlackPen = new Pen(Color.Black);
            PointF[] PointArray = new PointF[dwDataNum];
            PointF[] LPointArray = new PointF[dwDataNum];
            PointF[] LBaseArray = new PointF[1];

            Single YScaleUP=0;
            Single YScaleDown=0;
            switch (cbxAICfgCode.SelectedIndex)
            {

                case PCIELM4_DLL.PCIELM4_AI_BI_10V:
                    YScaleUP = 10.0F;
                    YScaleDown = -10.0F;
                    break;

                case PCIELM4_DLL.PCIELM4_AI_BI_5V:    //1  //Bipolar +/-  5V
                    YScaleUP = 5.0F;
                    YScaleDown = -5.0F;
                    break;

                case PCIELM4_DLL.PCIELM4_AI_BI_2V5:     //2 //Bipolar +/-  2.5V
                    YScaleUP = 2.5F;
                    YScaleDown = -2.5F;
                    break;

                case PCIELM4_DLL.PCIELM4_AI_BI_1V25:    //3 //Bipolar +/-  1.25V
                    YScaleUP = 1.25F;
                    YScaleDown = -1.25F;
                    break;
                case 4:    //3 //Bipolar +/-  1.25V
                    YScaleUP = 227.3F * 1.1F;
                    YScaleDown = -227.3F *1.1F;
                    break;
            }

            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                PointArray[i].X = i;
                PointArray[i].Y = (float)fBuf[i];
            }

            fScaleX = (float)pbxDisplay.Width / PointArray.Length;
  
            if (optAIFloat.Checked==true){ 
            fScaleY = (float)(pbxDisplay.Height * 0.97) / (Convert.ToSingle(((TextBox)YScale[0]).Text) - Convert.ToSingle(((TextBox)YScale[1]).Text));
            }else{
      
                fScaleY = (float)(pbxDisplay.Height * 0.97) / (YScaleUP - YScaleDown);
            }


            for (int i = PointArray.GetLowerBound(0); i <= PointArray.GetUpperBound(0); i++)
            {
                LPointArray[i].X = PointArray[i].X * fScaleX;
                
            if (optAIFloat.Checked ==true) {
                LPointArray[i].Y = ((Convert.ToSingle(((TextBox)YScale[0]).Text) - PointArray[i].Y) * fScaleY);
            }else{
                LPointArray[i].Y = ((YScaleUP- PointArray[i].Y) * fScaleY);
            }
            }
            pbxDisplay.Refresh();
            g.DrawLines(RedPen, LPointArray);


            RedPen.Dispose();
  
        }



        
       

         
    } 
}